function [A, objective_value] = bs_func_RDP(W, I, para)

alpha = 1/(1+para.mu);
D = 1./sqrt(sum(W, 2));
D = D*D';
[X, Y, V] = find(W);
if para.is_sparse
    W = sparse( double(W) );
    S = W.*double(D);
    A = double( I );
    I = double( I );
else
    S = W.*D;
    A = I;
end
objective_value = zeros(para.max_iter_diffusion, 1, 'single');

for iter = 1:para.max_iter_diffusion
%     tic;
    A = alpha*(S*A*S') + (1-alpha)*I;
%     toc;
    if para.if_debug
        objective_value(iter) = bs_compute_objective(A, D, X, Y, V, I, para);
        fprintf('After %d iteration, obj is %5.4f\n', iter, objective_value(iter) );
        if iter > 1
            if objective_value(iter-1)-objective_value(iter) < para.thres
                break;
            end
        end
    end
end
A = single(A);
objective_value = objective_value(1:iter);