clc;
clear;
close all;
addpath('LIB');
compile_func(0);

% replace with you own distances
M = 4;
N = 200;
Dist = cell(M, 1);
for ii = 1:M
    tmp = rand(N, N); tmp = tmp/2 + tmp'/2;
    Dist{ii} = tmp;
end
% convert to similarity
knn = 16;
sigma = 0.5;
Sim = cell(length(Dist), 1);
for ii = 1:length(Dist)
    Sim{ii} = bs_convert2sim_knn(Dist{ii}, knn, sigma);
end
%% fusion with diffusion
para.mu = 0.3;
para.max_iter_diffusion = 20; 
para.max_iter_alternating = 100;
para.if_debug = 1;
para.thres = 1e-3;
I = eye(size(Sim{1}), 'single');
para.is_sparse = 0;
para.fusion_type = 4;

switch para.fusion_type
    case 1 % 1: early fusion; 
        [A, obj] = bs_func_RDP(bs_mean_cell(Sim), I, para);
    case 2 % 2: late fusion;
        A_tmp = cell(length(Sim), 1);
        for ii = 1:length(Sim)
            [A_tmp{ii}, ~] = bs_func_RDP(Sim{ii}, I, para);
        end
        A = bs_mean_cell(A_tmp);
    case 3 % 3: tensor fusion;
        A = cell(length(Sim), length(Sim));
        for ii = 1:length(Sim)
            for jj = 1:length(Sim)
                [A{ii,jj}, obj] = bs_func_TPF({Sim{ii}; Sim{jj}}, I, para);
            end
        end 
    case 4 % RED
        para.beta = ones(length(Sim), 1)/length(Sim);
        para.lambda = 19;    % weight regularizor
        [A, out_beta, obj] = bs_func_RED(Sim, I, para);   
end